SixFrameRenderer (BioJava-1.5-beta API)
Keywords: org.biojava.bio.gui.sequence.SixFrameRenderer class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojava.bio.gui.sequence
Class SixFrameRenderer

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.gui.sequence.SixFrameRenderer

All Implemented Interfaces:
  SequenceRenderer, Changeable

    public class SixFrameRenderer

extends AbstractChangeable
implements SequenceRenderer

Class that handles drawing in six frames for other classes. Suitable for use with CDS features particularly.

Partly based on Matthew Pocock's ZiggyFeatureRenderer.

Author:
  David Huen

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.gui.sequence.SequenceRenderer
`SequenceRenderer.RendererForwarder`

Constructor Summary
`SixFrameRenderer()`

Method Summary
`void` | `drawLine(Graphics2D g, SequenceRenderContext src, int base, StrandedFeature.Strand strand)` draws required bar in correct translation frame.
`double` | `getBlockWidth()`
`double` | `getDepth(SequenceRenderContext src)` Retrieve the depth of this renderer when rendering src.
`Paint` | `getFill()`
`double` | `getMinimumLeader(SequenceRenderContext src)` Retrieve the minimum leading distance for this renderer when rendering src.
`double` | `getMinimumTrailer(SequenceRenderContext src)` Retrieve the minimum trailing distance for this renderer when rendering src.
`Paint` | `getOutline()`
`void` | `paint(Graphics2D g, SequenceRenderContext src)` Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.
`SequenceViewerEvent` | `processMouseEvent(SequenceRenderContext src, MouseEvent me, List path)` Produce a SequenceViewerEvent in response to a mouse gesture.
`void` | `renderLocation(Graphics2D g, SequenceRenderContext src, Location loc)` Render another "exon" in the correct translation frame.
`List` | `sequenceExtentOfPixels(SequenceRenderContext src)`
`void` | `setBlockWidth(double width)`
`void` | `setFill(Paint p)`
`void` | `setOutline(Paint p)`
`void` | `startZiggy(StrandedFeature.Strand strand)` Used to initialise the spliced transcript renderer for a CDS feature where the ends of the feature define the frame of the feature.
`void` | `startZiggy(StrandedFeature.Strand strand, int phase)` This method is called to initialise the renderer for a spliced transcript.

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, getChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SixFrameRenderer

    public SixFrameRenderer()

Method Detail

### getDepth

    public double getDepth(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the depth of this renderer when rendering src.

  The depth may vary between sequence panels - for example based upon sequence length. Each line of information in the SequenceRendererContext only renders a region of the sequence. The depth for one complete line may be different from that for another due to the sequence having more or less information in that region to show. For example, a feature renderer implementation may chose to collapse down to a depth of zero pixels if there are no features to render within a region.

  Specified by:
    `getDepth` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the depth of the renderer for that sequence panel

### getMinimumLeader

    public double getMinimumLeader(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum leading distance for this renderer when rendering src.

  The leading distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumLeader` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the leading distance of the renderer for that sequence panel

### getMinimumTrailer

    public double getMinimumTrailer(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum trailing distance for this renderer when rendering src.

  The trailing distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumTrailer` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the trailing distance of the renderer for that sequence panel

### setFill

    public void setFill(Paint p)
                 throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getFill

    public Paint getFill()

### setOutline

    public void setOutline(Paint p)
                    throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getOutline

    public Paint getOutline()

### setBlockWidth

    public void setBlockWidth(double width)
                       throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getBlockWidth

    public double getBlockWidth()

### startZiggy

    public void startZiggy(StrandedFeature.Strand strand)

  Used to initialise the spliced transcript renderer for a CDS feature where the ends of the feature define the frame of the feature.

### startZiggy

    public void startZiggy(StrandedFeature.Strand strand,
                           int phase)

  This method is called to initialise the renderer for a spliced transcript.

  Parameters:
    `strand` - the strand that the transcipt is on.
    `phase` - the initial translation phase of transcript coding region.

### renderLocation

    public void renderLocation(Graphics2D g,
                               SequenceRenderContext src,
                               Location loc)

  Render another "exon" in the correct translation frame.

### sequenceExtentOfPixels

    public List sequenceExtentOfPixels(SequenceRenderContext src)

### drawLine

    public void drawLine(Graphics2D g,
                         SequenceRenderContext src,
                         int base,
                         StrandedFeature.Strand strand)

  draws required bar in correct translation frame.

  Parameters:
    `base` - the sequence coordinate of the bar.
    `strand` - strand that the bar annotates.

### paint

    public void paint(Graphics2D g,
                      SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.

  Specified by:
    `paint` in interface `SequenceRenderer`
  Parameters:
    `g` - the Graphics2D to render to
    `src` - the SequenceRenderContext that encapsulates the information to render

### processMouseEvent

    public SequenceViewerEvent processMouseEvent(SequenceRenderContext src,
                                                 MouseEvent me,
                                                 List path)

  Description copied from interface: `SequenceRenderer`
  Produce a SequenceViewerEvent in response to a mouse gesture.

  A SequenceRenderer that performs any form of coordinate remapping should ensure that it appropriately transforms the mouse event. However, in the SequenceViewerEvent returned, the MouseEvent should be in untransformed coordinates.

  The SequenceRenderer implementation should append itself to the path list before constructing the SequenceViewerEvent.

  Specified by:
    `processMouseEvent` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext currently in scope
    `me` - a MouseEvent that caused this request
    `path` - the List of SequenceRenderer instances passed through so far
  Returns:
    a SequenceViewerEvent encapsulating the mouse gesture

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD